;;; Emacs customizations for editing BKGo code.
;;
;; (For now, it's just indentation standards.)

;; Mostly gnu-style, but we like curlies left-justified:
(defun bkgo-java-mode-hook ()
  (interactive) ; why not?
  (c-set-style "gnu")
  (c-set-offset 'substatement-open 0 t)
  (c-set-offset 'inline-open 0 t)
  )

(add-hook 'java-mode-hook 'bkgo-java-mode-hook)

;; For some reason, we actually need to run it by hand, because the
;; first time a file is loaded the hook doesn't take effect.  There's
;; some silly race-condition here, sigh.
(bkgo-java-mode-hook)
