
/**  This class is simply a stand-alone-app version of MessageServer:
     in other words, it includes a main().

     Usage:  java GoServer <portnum>

     (It's used by CGI to start a server)
     
*/


import java.io.*;


public class GoServer
{

  public static void main(String args[])
  {
    if (args.length != 1) {
      System.out.println("Usage:  java GoServer <portnum>");
      System.exit(1);
    }
    int port = Integer.parseInt(args[0]);

    try {
      MessageServer ms = new MessageServer(port);
      ms.start();
      System.out.println("Success: launched a MessageServer on port " + port);
    }
    catch (IOException e) {
      System.out.println("Error: " + e);
    }
  }

}










//////////////////////////////////////////////////////////
// Don't think, just hit `y':
//
// local variables:
// eval: (load-file "bkgomagic.el")
// end:
//////////////////////////////////////////////////////////
